VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WindowsFont"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Class:      SQLStudioUtil.WindowsFont
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

Private Const CF_SCREENFONTS = &H1
Private Const CF_PRINTERFONTS = &H2

Private Const LF_FACESIZE = 32
Private Const LF_FULLFACESIZE = 64


Public Type LOGFONT
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFacename(1 To LF_FACESIZE) As Byte
        'lfFacename As String * LF_FACESIZE
End Type

Public Type chooseFont
    lStructSize As Long
    hwndOwner As Long
    hdc As Long
    lpLogFont As Long
    iPointSize As Long
    flags As Long
    rgbColors As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
    hInstance As Long
    lpszStyle As String
    nFontType As Integer
    MISSING_ALIGNMENT As Integer
    nSizeMin As Long
    nSizeMax As Long
End Type



' Module name
Const MODULE_NAME = "SQLStudioUtil.WindowsFont"

'variable for the font handle
Private myFont As Long

'variable for a logfont structure
Private myLogFont As LOGFONT

'variable for the font handle
Private myWindowsHandle As Long
'=========================================================================================
'    property:      windowsLogFont
'    description:   set the logfont
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Public Property Let windowsLogFont(aLogFont As LOGFONT)
    On Error GoTo errLogFont
    
    Const FUNCTION_NAME = "Let windowsLogFont"
    
    myLogFont = aLogFont
    myFont = CreateFontIndirect(aLogFont)
    
    Exit Property
    
errLogFont:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      windowsLogFont
'    description:   get the logfont
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Public Property Get windowsLogFont() As LOGFONT
    On Error GoTo errLogFont
    
    Const FUNCTION_NAME = "Get windowsLogFont"
    
    windowsLogFont = myLogFont
    
    
    Exit Property
    
errLogFont:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      windowsHandle
'    description:   set the windows handle
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Public Property Let windowsHandle(aHandle As Long)
    On Error GoTo errHandle
    
    Const FUNCTION_NAME = "Let windowsHandle"
    
    myWindowsHandle = aHandle
    
     Exit Property
    
errHandle:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      windowsHandle
'    description:   get the windows Handle
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Public Property Get windowsHandle() As Long
    On Error GoTo errWindowsHandle
    
    Const FUNCTION_NAME = "Get windowsHandle"
    
    windowsHandle = myWindowsHandle
    
    Exit Property
    
errWindowsHandle:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Function changeAllFonts() As Boolean
   On Error GoTo errchangeAllFonts
    
    Const FUNCTION_NAME = "changeAllFonts"
    
    If myWindowsHandle = 0 Then
        MsgBox LoadResString(167)
        changeAllFonts = False
        Exit Function
    End If
    
    If myFont = 0 Then
        MsgBox LoadResString(168)
        changeAllFonts = False
        Exit Function
    End If
   
    EnumChildWindows myWindowsHandle, AddressOf changeAllFontsProc, myFont
    
    changeAllFonts = True
    
    Exit Function
    
errchangeAllFonts:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Private Sub Class_Initialize()
    On Error GoTo ErrClass_Initialize

    Const FUNCTION_NAME = "Class_Initialize"
    
    ' Inits
    myFont = 0
    myWindowsHandle = 0
    
    Exit Sub
    
ErrClass_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Public Function chooseFont(hWnd As Long) As Boolean
    On Error GoTo errgetFont

    
   Const FUNCTION_NAME = "getFont"
   
   Dim r  As Long
   Dim fontSelected As String
   Dim fontSizeSelected As Single
   Dim CFT As chooseFont
      
   CFT.hwndOwner = hWnd
   CFT.lpLogFont = VarPtr(myLogFont)
   CFT.flags = CF_SCREENFONTS
   CFT.nFontType = SCREEN_FONTTYPE
   CFT.lStructSize = Len(CFT)
   
   'dialog
   r = ChooseFontA(CFT)
   
   'canceled, or an error.
   If r = 0 Then
   
      r = CommDlgExtendedError()
      
      If r <> 0 Then
         MsgBox LoadResString(169) + String(r, 1)
         chooseFont = False
         Exit Function
      End If
   End If
   
   windowsHandle = hWnd
   windowsLogFont = myLogFont
   
   chooseFont = True
   
   Exit Function

    
errgetFont:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function


